import asyncio
import os
import sys
import time
import threading
from queue import Queue
from loguru import logger
from monitor import EventMonitor
from util import load_config
from rmq import RabbitMQProducer


def init_logger():
    logger.remove()
    logger.add(sys.stdout, level="INFO")


async def main():
    # LAZY HACK THIS IS BAD
    # TODO: Get rid of this trash and add retries if RabbitMQ isn't ready
    time.sleep(5)

    config = load_config("config.json")
    queue = Queue()
    monitor = EventMonitor(
        config={
            "infura_url": config['infura_url'],
            "pool_address": config['pool_address'],
            "etherscan_key": config['etherscan_key']
        },
        queue=queue
    )
    monitor_thread = threading.Thread(target=monitor.log_loop, args=(15,))
    monitor_thread.start()

    # RabbitMQ
    host = os.getenv("RABBITMQ_HOST", "localhost")
    port = 5672
    exchange = 'matrix_alerts'
    producer = RabbitMQProducer(host=host, port=port, exchange=exchange)

    while True:
        alert_text = queue.get()
        try:
            producer.send_event(message={'body': alert_text})
            queue.task_done()
        except Exception as e:
            logger.error(f"bigtime issue here: {e}")
            queue.put(alert_text)


        # try:
        #     await bot.send_markdown(event)
        #     await bot.logout()
        #     queue.task_done()
        # except nio.exceptions.LocalProtocolError:
        #     pass


if __name__ == '__main__':
    init_logger()
    asyncio.get_event_loop().run_until_complete(main())


# def main():
#     host = 'localhost'
#     port = 5672
#     exchange = 'matrix_alerts'
#
#     producer = RabbitMQProducer(host=host, port=port, exchange=exchange)
#
#     message = {'body': 'This is a test of RabbitMQ.'}
#     producer.send_event(message=message)
#
#     producer.close_connection()
#
#
# if __name__ == '__main__':
#     main()
